<?xml version="1.0" encoding="ascii"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
          "DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head>
  <title>bitten.util.xmlio.Element</title>
  <link rel="stylesheet" href="epydoc.css" type="text/css" />
  <script type="text/javascript" src="epydoc.js"></script>
</head>

<body bgcolor="white" text="black" link="blue" vlink="#204080"
      alink="#204080">
<!-- ==================== NAVIGATION BAR ==================== -->
<table class="navbar" border="0" width="100%" cellpadding="0"
       bgcolor="#a0c0ff" cellspacing="0">
  <tr valign="middle">
  <!-- Home link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="bitten-module.html">Home</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Tree link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="module-tree.html">Trees</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Index link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="identifier-index.html">Indices</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Help link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="help.html">Help</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Project homepage -->
      <th class="navbar" align="right" width="100%">
        <table border="0" cellpadding="0" cellspacing="0">
          <tr><th class="navbar" align="center"
            ><a class="navbar" target="_top" href="../index.html">Documentation Index</a></th>
          </tr></table></th>
  </tr>
</table>
<table width="100%" cellpadding="0" cellspacing="0">
  <tr valign="top">
    <td width="100%">
      <span class="breadcrumbs">
        <a href="bitten-module.html">Package&nbsp;bitten</a> ::
        <a href="bitten.util-module.html">Package&nbsp;util</a> ::
        <a href="bitten.util.xmlio-module.html">Module&nbsp;xmlio</a> ::
        Class&nbsp;Element
      </span>
    </td>
    <td>
      <table cellpadding="0" cellspacing="0">
        <!-- hide/show private -->
      </table>
    </td>
  </tr>
</table>
<!-- ==================== CLASS DESCRIPTION ==================== -->
<h1 class="epydoc">Class Element</h1><p class="nomargin-top"></p>
<pre class="base-tree">
object --+    
         |    
  <a href="bitten.util.xmlio.Fragment-class.html">Fragment</a> --+
             |
            <strong class="uidshort">Element</strong>
</pre>

<hr />
<p>Simple XML output generator based on the builder pattern.</p>
<p>Construct XML elements by passing the tag name to the constructor:</p>
<pre class="py-doctest">
<span class="py-prompt">&gt;&gt;&gt; </span><span class="py-keyword">print</span> Element(<span class="py-string">'foo'</span>)
<span class="py-output">&lt;foo/&gt;</span></pre>
<p>Attributes can be specified using keyword arguments. The values of the
arguments will be converted to strings and any special XML characters
escaped:</p>
<pre class="py-doctest">
<span class="py-prompt">&gt;&gt;&gt; </span><span class="py-keyword">print</span> Element(<span class="py-string">'foo'</span>, bar=42)
<span class="py-output">&lt;foo bar=&quot;42&quot;/&gt;</span>
<span class="py-output"></span><span class="py-prompt">&gt;&gt;&gt; </span><span class="py-keyword">print</span> Element(<span class="py-string">'foo'</span>, bar=<span class="py-string">'1 &lt; 2'</span>)
<span class="py-output">&lt;foo bar=&quot;1 &amp;lt; 2&quot;/&gt;</span>
<span class="py-output"></span><span class="py-prompt">&gt;&gt;&gt; </span><span class="py-keyword">print</span> Element(<span class="py-string">'foo'</span>, bar=<span class="py-string">'&quot;baz&quot;'</span>)
<span class="py-output">&lt;foo bar=&quot;&amp;quot;baz&amp;quot;&quot;/&gt;</span></pre>
<p>The order in which attributes are rendered is undefined.</p>
<p>Elements can be using item access notation:</p>
<pre class="py-doctest">
<span class="py-prompt">&gt;&gt;&gt; </span><span class="py-keyword">print</span> Element(<span class="py-string">'foo'</span>)[Element(<span class="py-string">'bar'</span>), Element(<span class="py-string">'baz'</span>)]
<span class="py-output">&lt;foo&gt;&lt;bar/&gt;&lt;baz/&gt;&lt;/foo&gt;</span></pre>
<p>Text nodes can be nested in an element by using strings instead of elements
in item access. Any special characters in the strings are escaped
automatically:</p>
<pre class="py-doctest">
<span class="py-prompt">&gt;&gt;&gt; </span><span class="py-keyword">print</span> Element(<span class="py-string">'foo'</span>)[<span class="py-string">'Hello world'</span>]
<span class="py-output">&lt;foo&gt;Hello world&lt;/foo&gt;</span>
<span class="py-output"></span><span class="py-prompt">&gt;&gt;&gt; </span><span class="py-keyword">print</span> Element(<span class="py-string">'foo'</span>)[42]
<span class="py-output">&lt;foo&gt;42&lt;/foo&gt;</span>
<span class="py-output"></span><span class="py-prompt">&gt;&gt;&gt; </span><span class="py-keyword">print</span> Element(<span class="py-string">'foo'</span>)[<span class="py-string">'1 &lt; 2'</span>]
<span class="py-output">&lt;foo&gt;1 &amp;lt; 2&lt;/foo&gt;</span></pre>
<p>This technique also allows mixed content:</p>
<pre class="py-doctest">
<span class="py-prompt">&gt;&gt;&gt; </span><span class="py-keyword">print</span> Element(<span class="py-string">'foo'</span>)[<span class="py-string">'Hello '</span>, Element(<span class="py-string">'b'</span>)[<span class="py-string">'world'</span>]]
<span class="py-output">&lt;foo&gt;Hello &lt;b&gt;world&lt;/b&gt;&lt;/foo&gt;</span></pre>
<p>Finally, text starting with an opening angle bracket is treated specially:
under the assumption that the text actually contains XML itself, the whole
thing is wrapped in a CDATA block instead of escaping all special characters
individually:</p>
<pre class="py-doctest">
<span class="py-prompt">&gt;&gt;&gt; </span><span class="py-keyword">print</span> Element(<span class="py-string">'foo'</span>)[<span class="py-string">'&lt;bar a=&quot;3&quot; b=&quot;4&quot;&gt;&lt;baz/&gt;&lt;/bar&gt;'</span>]
<span class="py-output">&lt;foo&gt;&lt;![CDATA[&lt;bar a=&quot;3&quot; b=&quot;4&quot;&gt;&lt;baz/&gt;&lt;/bar&gt;]]&gt;&lt;/foo&gt;</span></pre>
<p>Valid input are utf-8 or unicode strings, or any type easily converted
to unicode such as integers. Output is always utf-8.</p>

<!-- ==================== INSTANCE METHODS ==================== -->
<a name="section-InstanceMethods"></a>
<table class="summary" border="1" cellpadding="3"
       cellspacing="0" width="100%" bgcolor="white">
<tr bgcolor="#70b0f0" class="table-header">
  <td align="left" colspan="2" class="table-header">
    <span class="table-header">Instance Methods</span></td>
</tr>
<tr>
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type">&nbsp;</span>
    </td><td class="summary">
      <table width="100%" cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td><span class="summary-sig"><a href="bitten.util.xmlio.Element-class.html#__init__" class="summary-sig-name">__init__</a>(<span class="summary-sig-arg">self</span>,
        <span class="summary-sig-arg">name_</span>,
        <span class="summary-sig-arg">**attr</span>)</span><br />
      Create an XML element using the specified tag name.</td>
          <td align="right" valign="top">
            
            
          </td>
        </tr>
      </table>
      
    </td>
  </tr>
<tr>
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type">&nbsp;</span>
    </td><td class="summary">
      <table width="100%" cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td><span class="summary-sig"><a href="bitten.util.xmlio.Element-class.html#write" class="summary-sig-name">write</a>(<span class="summary-sig-arg">self</span>,
        <span class="summary-sig-arg">out</span>,
        <span class="summary-sig-arg">newlines</span>=<span class="summary-sig-default">False</span>)</span><br />
      Serializes the element and writes the XML to the given output
stream.</td>
          <td align="right" valign="top">
            
            
          </td>
        </tr>
      </table>
      
    </td>
  </tr>
  <tr>
    <td colspan="2" class="summary">
    <p class="indent-wrapped-lines"><b>Inherited from <code><a href="bitten.util.xmlio.Fragment-class.html">Fragment</a></code></b>:
      <code><a href="bitten.util.xmlio.Fragment-class.html#__getitem__">__getitem__</a></code>,
      <code><a href="bitten.util.xmlio.Fragment-class.html#__str__">__str__</a></code>,
      <code><a href="bitten.util.xmlio.Fragment-class.html#append">append</a></code>
      </p>
    <p class="indent-wrapped-lines"><b>Inherited from <code>object</code></b>:
      <code>__delattr__</code>,
      <code>__format__</code>,
      <code>__getattribute__</code>,
      <code>__hash__</code>,
      <code>__new__</code>,
      <code>__reduce__</code>,
      <code>__reduce_ex__</code>,
      <code>__repr__</code>,
      <code>__setattr__</code>,
      <code>__sizeof__</code>,
      <code>__subclasshook__</code>
      </p>
    </td>
  </tr>
</table>
<!-- ==================== PROPERTIES ==================== -->
<a name="section-Properties"></a>
<table class="summary" border="1" cellpadding="3"
       cellspacing="0" width="100%" bgcolor="white">
<tr bgcolor="#70b0f0" class="table-header">
  <td align="left" colspan="2" class="table-header">
    <span class="table-header">Properties</span></td>
</tr>
<tr>
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type">&nbsp;</span>
    </td><td class="summary">
        <a name="attr"></a><span class="summary-name">attr</span>
    </td>
  </tr>
<tr>
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type">&nbsp;</span>
    </td><td class="summary">
        <a name="name"></a><span class="summary-name">name</span>
    </td>
  </tr>
  <tr>
    <td colspan="2" class="summary">
    <p class="indent-wrapped-lines"><b>Inherited from <code><a href="bitten.util.xmlio.Fragment-class.html">Fragment</a></code></b>:
      <code><a href="bitten.util.xmlio.Fragment-class.html#children">children</a></code>
      </p>
    <p class="indent-wrapped-lines"><b>Inherited from <code>object</code></b>:
      <code>__class__</code>
      </p>
    </td>
  </tr>
</table>
<!-- ==================== METHOD DETAILS ==================== -->
<a name="section-MethodDetails"></a>
<table class="details" border="1" cellpadding="3"
       cellspacing="0" width="100%" bgcolor="white">
<tr bgcolor="#70b0f0" class="table-header">
  <td align="left" colspan="2" class="table-header">
    <span class="table-header">Method Details</span></td>
</tr>
</table>
<a name="__init__"></a>
<div>
<table class="details" border="1" cellpadding="3"
       cellspacing="0" width="100%" bgcolor="white">
<tr><td>
  <table width="100%" cellpadding="0" cellspacing="0" border="0">
  <tr valign="top"><td>
  <h3 class="epydoc"><span class="sig"><span class="sig-name">__init__</span>(<span class="sig-arg">self</span>,
        <span class="sig-arg">name_</span>,
        <span class="sig-arg">**attr</span>)</span>
    <br /><em class="fname">(Constructor)</em>
  </h3>
  </td><td align="right" valign="top"
    >&nbsp;
    </td>
  </tr></table>
  
  <p>Create an XML element using the specified tag name.</p>
<p>The tag name must be supplied as the first positional argument. All
keyword arguments following it are handled as attributes of the element.</p>
  <dl class="fields">
    <dt>Overrides:
        object.__init__
    </dt>
  </dl>
</td></tr></table>
</div>
<a name="write"></a>
<div>
<table class="details" border="1" cellpadding="3"
       cellspacing="0" width="100%" bgcolor="white">
<tr><td>
  <table width="100%" cellpadding="0" cellspacing="0" border="0">
  <tr valign="top"><td>
  <h3 class="epydoc"><span class="sig"><span class="sig-name">write</span>(<span class="sig-arg">self</span>,
        <span class="sig-arg">out</span>,
        <span class="sig-arg">newlines</span>=<span class="sig-default">False</span>)</span>
  </h3>
  </td><td align="right" valign="top"
    >&nbsp;
    </td>
  </tr></table>
  
  Serializes the element and writes the XML to the given output
stream.
  <dl class="fields">
    <dt>Overrides:
        <a href="bitten.util.xmlio.Fragment-class.html#write">Fragment.write</a>
    </dt>
  </dl>
</td></tr></table>
</div>
<br />
<!-- ==================== NAVIGATION BAR ==================== -->
<table class="navbar" border="0" width="100%" cellpadding="0"
       bgcolor="#a0c0ff" cellspacing="0">
  <tr valign="middle">
  <!-- Home link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="bitten-module.html">Home</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Tree link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="module-tree.html">Trees</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Index link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="identifier-index.html">Indices</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Help link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="help.html">Help</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Project homepage -->
      <th class="navbar" align="right" width="100%">
        <table border="0" cellpadding="0" cellspacing="0">
          <tr><th class="navbar" align="center"
            ><a class="navbar" target="_top" href="../index.html">Documentation Index</a></th>
          </tr></table></th>
  </tr>
</table>
<table border="0" cellpadding="0" cellspacing="0" width="100%%">
  <tr>
    <td align="left" class="footer">
    Generated by Epydoc 3.0.1 on Fri Mar 11 14:53:36 2011
    </td>
    <td align="right" class="footer">
      <a target="mainFrame" href="http://epydoc.sourceforge.net"
        >http://epydoc.sourceforge.net</a>
    </td>
  </tr>
</table>

<script type="text/javascript">
  <!--
  // Private objects are initially displayed (because if
  // javascript is turned off then we want them to be
  // visible); but by default, we want to hide them.  So hide
  // them unless we have a cookie that says to show them.
  checkCookie();
  // -->
</script>
</body>
</html>
